// DWFGoogleDesktopCrawl.cpp : Implementation of DLL Exports.

#include "stdafx.h"
#include "resource.h"
#include "DWFGoogleDesktopCrawl.h"
#include "GoogleDesktopSearchAPI.h"
#include "dlldatax.h"

class CDWFGoogleDesktopCrawlModule : public CAtlDllModuleT< CDWFGoogleDesktopCrawlModule >
{
public :
	DECLARE_LIBID(LIBID_DWFGoogleDesktopCrawlLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_DWFGOOGLEDESKTOPCRAWL, "{EB400D9B-EC55-4BCD-9A3A-4D4CD6BFB945}")
};

CDWFGoogleDesktopCrawlModule _AtlModule;



STDAPI GoogleRegister()
{
	::CoInitialize( NULL );

	HRESULT hr;

	CComPtr<IGoogleDesktopSearchComponentRegister> spGoogleRegister;
	hr = spGoogleRegister.CoCreateInstance( CLSID_GoogleDesktopSearchRegister );

	if (SUCCEEDED(hr))
	{
		CStringW zModule;
		CStringW zIcon;

		::GetModuleFileNameW( _AtlBaseModule.GetModuleInstance(), CStrBufW(zModule, 1024), 1023 );
		zIcon.Format( L"%ls,%d", zModule, IDI_ICON1 );

		CComSafeArray<VARIANT> aDescription( 6 );

		aDescription.SetAt( 0, CComVariant(L"Title") );
		aDescription.SetAt( 1, CComVariant(L"DWF") );
		aDescription.SetAt( 2, CComVariant(L"Description") );
		aDescription.SetAt( 3, CComVariant(L"Autodesk DWF Plug-in") );
		aDescription.SetAt( 4, CComVariant(L"Icon") );
		aDescription.SetAt( 5, CComVariant(zIcon) );

		CComBSTR bstrCLSID( CLSID_DWFCrawlHandler );

		CComVariant vDescription( aDescription.m_psa );
		CComPtr<IGoogleDesktopSearchComponentRegistration> spGoogleRegistration;
		hr = spGoogleRegister->RegisterComponent( bstrCLSID, vDescription, &spGoogleRegistration );

		if (SUCCEEDED(hr))
		{
			hr = spGoogleRegistration->RegisterExtension( CComBSTR(L"dwf") );

			if (FAILED(hr)) 
			{
				spGoogleRegister->UnregisterComponent( bstrCLSID );
			}
		}
	}

	::CoUninitialize();
	return hr;
}

STDAPI GoogleUnregister()
{
	::CoInitialize( NULL );

	HRESULT hr;

	CComPtr<IGoogleDesktopSearchComponentRegister> spGoogleRegister;
	hr = spGoogleRegister.CoCreateInstance( CLSID_GoogleDesktopSearchRegister );

	if (SUCCEEDED(hr))
	{
		CComBSTR bstrCLSID( CLSID_DWFCrawlHandler );
		hr = spGoogleRegister->UnregisterComponent( bstrCLSID );
	}

	::CoUninitialize();
	return hr;
}


// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
#ifdef _MERGE_PROXYSTUB
    if (!PrxDllMain(hInstance, dwReason, lpReserved))
        return FALSE;
#endif
	hInstance;
    return _AtlModule.DllMain(dwReason, lpReserved); 
}


// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
#ifdef _MERGE_PROXYSTUB
    HRESULT hr = PrxDllCanUnloadNow();
    if (FAILED(hr))
        return hr;
#endif
    return _AtlModule.DllCanUnloadNow();
}


// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
#ifdef _MERGE_PROXYSTUB
    if (PrxDllGetClassObject(rclsid, riid, ppv) == S_OK)
        return S_OK;
#endif
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}


// DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    HRESULT hr = _AtlModule.DllRegisterServer();

	if (SUCCEEDED(hr))
	{
		GoogleRegister();
	}

#ifdef _MERGE_PROXYSTUB
    if (FAILED(hr))
        return hr;
    hr = PrxDllRegisterServer();
#endif
	return hr;
}


// DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
	GoogleUnregister();
	HRESULT hr = _AtlModule.DllUnregisterServer();
#ifdef _MERGE_PROXYSTUB
    if (FAILED(hr))
        return hr;
    hr = PrxDllRegisterServer();
    if (FAILED(hr))
        return hr;
    hr = PrxDllUnregisterServer();
#endif
	return hr;
}
