#include "whiptk/whip_toolkit.h"

extern WT_File whip_file; //Assume this has been opened for writing elsewhere.

WT_Result LineStyle()
{
    //Store the previous line style.
    WT_Line_Style previous_style = whip_file.desired_rendition().line_style();
    //Create a new line style.
    WT_Line_Style style;
    style.line_start_cap() = style.line_end_cap() = WT_Line_Style::Butt_Cap;
    style.dash_start_cap() = style.dash_end_cap() = WT_Line_Style::Round_Cap;
    style.line_join() = WT_Line_Style::Miter_Join;
    style.adapt_patterns() = WD_False;
    style.pattern_scale() = 50;
    //Set the new line style active.
    whip_file.desired_rendition().line_style() = style;
    //Create some geometry.
    int x=0,y=0;
    WT_Logical_Point vP[2];
    vP[0] = WT_Logical_Point(x,y);
    vP[1] = WT_Logical_Point(x+100,y);
    WT_Polyline p1 (2, vP, WD_True);
    //Serialize it.
    WD_CHECK(p1.serialize (whip_file));

    //Modify the style.
    style.adapt_patterns() = WD_True;
    style.pattern_scale() = 0;
    //Set the new line style active.
    whip_file.desired_rendition().line_style() = style;
    //Create some geometry.
    vP[0] = WT_Logical_Point(x,y+100);
    vP[1] = WT_Logical_Point(x+100,y+100);
    WT_Polyline p2 (2, vP, WD_True);
    //Serialize it.
    WD_CHECK(p2.serialize (whip_file));

    //Restore the original style.
    whip_file.desired_rendition().line_style() = previous_style;
    
    return WT_Result::Success;
}